Loading...
Searching...
No Matches
pcl::GFPFHEstimation< PointInT, PointLT, PointOutT > Class Template Reference
Module features

GFPFHEstimation estimates the Global Fast Point Feature Histogram (GFPFH) descriptor for a given point cloud dataset containing points and labels. More...

`#include <pcl/features/gfpfh.h>`

Inheritance diagram for pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >:

## Public Types

using | Ptr = shared_ptr<GFPFHEstimation<PointInT, PointLT, PointOutT> >
using | ConstPtr = shared_ptr<const GFPFHEstimation<PointInT, PointLT, PointOutT> >
using | PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut
using | PointCloudIn = typename Feature<PointInT, PointOutT>::PointCloudIn
Public Types inherited from pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >
using | Ptr = shared_ptr< FeatureFromLabels<PointInT, PointLT, PointOutT> >
using | ConstPtr = shared_ptr< const FeatureFromLabels<PointInT, PointLT, PointOutT> >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase<PointInT>
using | Ptr = shared_ptr< Feature<PointInT, PointOutT> >
using | ConstPtr = shared_ptr< const Feature<PointInT, PointOutT> >
using | KdTree = pcl::search::Search<PointInT>
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud<PointInT>
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud<PointOutT>
using | SearchMethod = std::function<int (std::size_t, double, pcl::Indices &, std::vector<float> &)>
using | SearchMethodSurface = std::function<int (const PointCloudIn &cloud, std::size_t index, double, pcl::Indices &, std::vector<float> &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| GFPFHEstimation ()
| Empty constructor.
void | setOctreeLeafSize (double size)
| Set the size of the octree leaves.
double | getOctreeLeafSize ()
| Get the sphere radius used for determining the neighbors.
std::uint32_t | emptyLabel () const
| Return the empty label value.
std::uint32_t | getNumberOfClasses () const
| Return the number of different classes.
void | setNumberOfClasses (std::uint32_t n)
| Set the number of different classes.
int | descriptorSize () const
| Return the size of the descriptor.
void | compute (PointCloudOut &output)
| Overloaded computed method from pcl::Feature.
Public Member Functions inherited from pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >
| FeatureFromLabels ()
| Empty constructor.
void | setInputLabels (const PointCloudLConstPtr &labels)
| Provide a pointer to the input dataset that contains the point labels of the XYZ dataset.
PointCloudLConstPtr | getInputLabels () const
| Get a pointer to the labels of the input XYZ point cloud dataset.
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Estimate the Point Feature Histograms (PFH) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
std::uint32_t | getDominantLabel (const pcl::Indices &indices)
| Return the dominant label of a set of points.
void | computeTransitionHistograms (const std::vector< std::vector< int > > &label_histograms, std::vector< std::vector< int > > &transition_histograms)
| Compute the fixed-length histograms of transitions.
void | computeDistancesToMean (const std::vector< std::vector< int > > &transition_histograms, std::vector< float > &distances)
| Compute the distance of each transition histogram to the mean.
float | computeHIKDistance (const std::vector< int > &histogram, const std::vector< float > &mean_histogram)
| Return the Intersection Kernel distance between two histograms.
void | computeDistanceHistogram (const std::vector< float > &distances, std::vector< float > &histogram)
| Compute the binned histogram of distance values.
void | computeMeanHistogram (const std::vector< std::vector< int > > &histograms, std::vector< float > &mean_histogram)
| Compute the mean histogram of the given set of histograms.
Protected Member Functions inherited from pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >
PointCloudLConstPtr | labels_
| A pointer to the input dataset that contains the point labels of the XYZ dataset.
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointLT, typename PointOutT>
class pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >

GFPFHEstimation estimates the Global Fast Point Feature Histogram (GFPFH) descriptor for a given point cloud dataset containing points and labels.

Note
  If you use this code in any academic work, please cite:

- R.B. Rusu, A. Holzbach, M. Beetz. Detecting and Segmenting Objects for Mobile Manipulation. In the S3DV Workshop of the 12th International Conference on Computer Vision (ICCV), 2009.

Author
  Radu B. Rusu

Template Parameters

  PointOutT | Suggested type is pcl::GFPFHSignature16

Definition at line 65 of file gfpfh.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointLT, typename PointOutT>

using pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::ConstPtr = shared_ptr<const GFPFHEstimation<PointInT, PointLT, PointOutT> >

Definition at line 69 of file gfpfh.h.

## PointCloudIn

template<typename PointInT, typename PointLT, typename PointOutT>

using pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::PointCloudIn = typename Feature<PointInT, PointOutT>::PointCloudIn

Definition at line 81 of file gfpfh.h.

## PointCloudOut

template<typename PointInT, typename PointLT, typename PointOutT>

using pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 80 of file gfpfh.h.

## Ptr

template<typename PointInT, typename PointLT, typename PointOutT>

using pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::Ptr = shared_ptr<GFPFHEstimation<PointInT, PointLT, PointOutT> >

Definition at line 68 of file gfpfh.h.

## Constructor & Destructor Documentation

## GFPFHEstimation()

template<typename PointInT, typename PointLT, typename PointOutT>

pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::GFPFHEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 84 of file gfpfh.h.

References descriptorSize(), and pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## compute()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::compute | ( | PointCloudOut & | output | ) |

Overloaded computed method from pcl::Feature.

Parameters

  [out] | output | the resultant point cloud model dataset containing the estimated features

Definition at line 53 of file gfpfh.hpp.

References computeFeature(), pcl::Feature< PointInT, PointOutT >::deinitCompute(), pcl::Feature< PointInT, PointOutT >::initCompute(), and pcl::PCLBase< PointInT >::input_.

## computeDistanceHistogram()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::computeDistanceHistogram | ( | const std::vector< float > & | distances,
|  | std::vector< float > & | histogram )

protected

Compute the binned histogram of distance values.

Definition at line 196 of file gfpfh.hpp.

References descriptorSize().

Referenced by computeFeature().

## computeDistancesToMean()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::computeDistancesToMean | ( | const std::vector< std::vector< int > > & | transition_histograms,
|  | std::vector< float > & | distances )

protected

Compute the distance of each transition histogram to the mean.

Definition at line 179 of file gfpfh.hpp.

References computeHIKDistance(), and computeMeanHistogram().

Referenced by computeFeature().

## computeFeature()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Estimate the Point Feature Histograms (PFH) descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().

Parameters

  output | the resultant point cloud model dataset that contains the PFH feature estimates

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 80 of file gfpfh.hpp.

References computeDistanceHistogram(), computeDistancesToMean(), computeTransitionHistograms(), emptyLabel(), getDominantLabel(), and pcl::PCLBase< PointInT >::input_.

Referenced by compute().

## computeHIKDistance()

template<typename PointInT, typename PointNT, typename PointOutT>

float pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::computeHIKDistance | ( | const std::vector< int > & | histogram,
|  | const std::vector< float > & | mean_histogram )

protected

Return the Intersection Kernel distance between two histograms.

Definition at line 239 of file gfpfh.hpp.

Referenced by computeDistancesToMean().

## computeMeanHistogram()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::computeMeanHistogram | ( | const std::vector< std::vector< int > > & | histograms,
|  | std::vector< float > & | mean_histogram )

protected

Compute the mean histogram of the given set of histograms.

Definition at line 223 of file gfpfh.hpp.

Referenced by computeDistancesToMean().

## computeTransitionHistograms()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::computeTransitionHistograms | ( | const std::vector< std::vector< int > > & | label_histograms,
|  | std::vector< std::vector< int > > & | transition_histograms )

protected

Compute the fixed-length histograms of transitions.

Definition at line 138 of file gfpfh.hpp.

References getNumberOfClasses().

Referenced by computeFeature().

## descriptorSize()

template<typename PointInT, typename PointLT, typename PointOutT>

int pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::descriptorSize | ( |  | ) | const

inline

Return the size of the descriptor.

Definition at line 116 of file gfpfh.h.

Referenced by computeDistanceHistogram(), and GFPFHEstimation().

## emptyLabel()

template<typename PointInT, typename PointLT, typename PointOutT>

std::uint32_t pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::emptyLabel | ( |  | ) | const

inline

Return the empty label value.

Definition at line 102 of file gfpfh.h.

Referenced by computeFeature(), and getDominantLabel().

## getDominantLabel()

template<typename PointInT, typename PointNT, typename PointOutT>

std::uint32_t pcl::GFPFHEstimation< PointInT, PointNT, PointOutT >::getDominantLabel | ( | const pcl::Indices & | indices | ) |

protected

Return the dominant label of a set of points.

Definition at line 254 of file gfpfh.hpp.

References emptyLabel(), and getNumberOfClasses().

Referenced by computeFeature().

## getNumberOfClasses()

template<typename PointInT, typename PointLT, typename PointOutT>

std::uint32_t pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::getNumberOfClasses | ( |  | ) | const

inline

Return the number of different classes.

Definition at line 106 of file gfpfh.h.

Referenced by computeTransitionHistograms(), and getDominantLabel().

## getOctreeLeafSize()

template<typename PointInT, typename PointLT, typename PointOutT>

double pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::getOctreeLeafSize | ( |  | ) |

inline

Get the sphere radius used for determining the neighbors.

Definition at line 98 of file gfpfh.h.

## setNumberOfClasses()

template<typename PointInT, typename PointLT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::setNumberOfClasses | ( | std::uint32_t | n | ) |

inline

Set the number of different classes.

Parameters

  n | number of different classes.

Definition at line 112 of file gfpfh.h.

## setOctreeLeafSize()

template<typename PointInT, typename PointLT, typename PointOutT>

void pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::setOctreeLeafSize | ( | double | size | ) |

inline

Set the size of the octree leaves.

Definition at line 94 of file gfpfh.h.

The documentation for this class was generated from the following files:

- pcl/features/gfpfh.h
- pcl/features/impl/gfpfh.hpp